package com.nisum.reactive.dto;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.*;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class ProductDto {

    private String id;

    @NotBlank(message = "Product Name shouldn't be null or empty")
    private String name;

    @DecimalMin(value = "1.0", message = "Please Enter a valid Price")
    private double price;

    // annotation
    @Min(1)
    @Max(5)
    @NotNull
    private int qty;
}
