package com.nisum.reactive.router;

import com.nisum.reactive.routerHandler.ProductKafkaHndler;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.reactive.function.server.RouterFunction;
import org.springframework.web.reactive.function.server.RouterFunctions;
import org.springframework.web.reactive.function.server.ServerResponse;
import static org.springframework.web.reactive.function.server.RequestPredicates.GET;
import static org.springframework.web.reactive.function.server.RequestPredicates.POST;
import static org.springframework.web.reactive.function.server.RequestPredicates.PUT;
import static org.springframework.web.reactive.function.server.RequestPredicates.DELETE;
import static org.springframework.web.reactive.function.server.RouterFunctions.route;

@Configuration
public class RouterConfig {

    @Bean
    public RouterFunction<ServerResponse> routes(ProductKafkaHndler postController) {
        return route(GET("/route/kafkaStringMsg/{name}"), postController::publishMessage)
                .andRoute(GET("/route/products"), postController::getAllProducts)
                .andRoute(POST("/route/products/save"), postController::saveProduct)
                .andRoute(GET("/route/product/{id}"), postController::findProduct)
                .andRoute(PUT("/route/product/{id}"), postController::updateProduct)
                .andRoute(DELETE("/route/product/{id}"), postController::deleteProduct);
    }
}
